var global = this;

global.twistit = new function() {
    var twistit = this;

    this.XMLHttpRequest = function() {
        return new XMLHttpRequest();
    };
 

    this.windowSize = function() {
	      if (window.innerWidth)
	      {
		        frameWidth = window.innerWidth;
		        frameHeight = window.innerHeight;
	      }
	      else if (document.documentElement && document.documentElement.clientWidth)
	      {
		        frameWidth = document.documentElement.clientWidth;
		        frameHeight = document.documentElement.clientHeight;
	      }
	      else if (document.body)
	      {
		        frameWidth = document.body.clientWidth;
		        frameHeight = document.body.clientHeight;
	      }
        return [frameWidth, frameHeight];
    };

    this.nodePosition = function(node) {
 //        var curleft = 0;
//         var curtop = 0;
//         if(node.offsetParent) {
//             while(node.offsetParent) {
//                 curleft += node.offsetLeft;
//                 curtop += node.offsetTop;
//                 node = node.offsetParent;
//             }
//         }
//         return [curleft, curtop];
        var oX = 0;
        var oY = 0;
        if (node.offsetParent) {
            while (1) {
                oX+=node.offsetLeft;
                oY+=node.offsetTop;
                if (!node.offsetParent) {
                    break;
                }
                node=node.offsetParent;
            }
        } else if (node.x) {
            oX+=node.x;
            oY+=node.y;
        }

        return [oX, oY];
    };
   

    this.currentBlock = null;

    this.selectBlock = function(blockId) {
        var block = document.getElementById(blockId);
        if(this.currentBlock) {
            this.currentBlock.style.background = 'url(/bluebliss/back_off.png)';

            if(this.currentBlock == block) {
                this.currentBlock = null;
                this.hideTurnButtons();
                return;
            }
        }

        block.style.background = 'url(/bluebliss/back_on.png)';
        this.currentBlock = block;
        this.showTurnButtons();
    };

    this.showTurnButtons = function() {
        var block = this.currentBlock;
        var x = parseInt(block.getAttribute('blockx'));
        var y = parseInt(block.getAttribute('blocky'));
        
        var sizeX = parseInt(block.getAttribute('sizex'));
        var sizeY = parseInt(block.getAttribute('sizey'));

        var blockSizeX = (670 / sizeX);
        var blockSizeY = (590 / sizeX);

        var offsetX = x * blockSizeX + (blockSizeX / 2);
        var offsetY = y * blockSizeY + (blockSizeY / 2);

        var windowSize = this.windowSize();
        
        var buttons = document.getElementById('turn-buttons');
        buttons.style.display = 'block';

        buttons.style.left = ((windowSize[0] / 2) + 280 - 500 + offsetX) + 'px';
        buttons.style.top = ((windowSize[1] / 2)  - 330 + offsetY) + 'px';
    };

    this.hideTurnButtons = function() {
        var buttons = document.getElementById('turn-buttons');
        buttons.style.display = 'none';
    };

    this.convertHTMLToNodes = function(html){
        var node = document.createElement('div');
        node.innerHTML = html;
        var resultNodes = [];
        for (var i=0; i<node.childNodes.length; i++) {
            resultNodes.push(node.childNodes.item(i));
        }
        return resultNodes;
    };


    this.rotate = function(direction){
// if (!e) var e = window.event;
// 	e.cancelBubble = true;
// 	if (e.stopPropagation) e.stopPropagation();

        var blockid = this.currentBlock.getAttribute('blockid');

        var xmlhttp = this.XMLHttpRequest();
        xmlhttp.open('GET', '/game/rotate/' + blockid + '/' + direction, true);
        xmlhttp.onreadystatechange = function() {
            if(xmlhttp.readyState != 4) return;

            var nodes = twistit.convertHTMLToNodes(xmlhttp.responseText);
            var length = nodes.length;
            var parentNode = twistit.currentBlock.parentNode;
            var next = nodes[length-1];
            parentNode.replaceChild(next, twistit.currentBlock);
            for (var i=length-2; i>=0; i--) {
                var inserted = parentNode.insertBefore(nodes[i], next);
                next = inserted;
            }
            twistit.hideTurnButtons();

            if(xmlhttp.getResponseHeader("x-is-solved") == 'True') {
                alert('Solved');
            }
        };
        xmlhttp.send(null);

        twistit.updateCounter();
    };

    this.rotateLeft = function() {
        this.rotate('left');
    };

    this.rotateRight = function() {
        this.rotate('right');
    };

    this.updateCounter = function() {
        var counter = document.getElementById('counter');
        var steps = parseInt(counter.getAttribute('stepsleft')) - 1;

        if(steps <= 0){
            alert('Game over');
        }


        var stepsString = '' + steps;
        
        // padd the steps string with zero's
        var padding = stepsString.length
        for(var i=0; i<3-padding; i++){
            stepsString = '0' + stepsString;
        }

        for(var i=0; i<3; i++){
            var digit = document.getElementById('counter-' + i);
            digit.className = 'dig-' + stepsString.charAt(i);
        }

        counter.setAttribute('stepsleft', ''+steps);
    }
}